#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdbool.h>


typedef struct maillon
{
    char departement[30];
    int nbPers;
    char responsable[30];
    struct maillon *suiv;
}MaillonDept;

typedef MaillonDept* ListeDept;

typedef struct
{
    char ville[30];
    MaillonDept *idDept;
}VilleIUT;

//#########################################
//#########################################
//#########################################

typedef struct maillonCandidDept
{
    char departement[30];
    int decisionDept;
    int decisionCandid;
    struct maillonCandidDept *suiv;
}MaillonCandidDept, *ListeCandidDept;

typedef struct maillonEtu
{
    char iutCandid[30];
    MaillonCandidDept *idCandDept;
    struct maillonEtu *suiv;
}MaillonCandid, *ListeCandid;


typedef struct
{
    int id;
    char nom[30];
    char prenom[30];
    float note[4];
    MaillonCandid *idCandIUT;
}Candidat;

//#########################################
//#########################################
//#########################################

bool motdepasseVerif(void);

bool verifQuit(void);

int menuUtilisateurAffiche(void);

int menuAdminAffiche(void);

void gestionMenu(VilleIUT **tiut, int nbEle);

int gestionMenuAdmin(VilleIUT **tiut, int nbEle);

void global(void);

void AffichageVille(VilleIUT **tiut, int nbEle);

void AffichageGlobalDepVille(VilleIUT **tiut, int nbEle);

void AffichageNbplaceDept(VilleIUT **tiut, int nbEle);

int rechVille(VilleIUT **tiut, int nbEle, char code[], int *trouve);

void AffichageNbplaceDeptVille(VilleIUT **tiut, int nbEle);

void AffichageDepVille(VilleIUT **tiut, int nbEle);

void AffichageDeptVille(VilleIUT **tiut, int nbEle);

void AffichageGlobalIUT(VilleIUT **tiut, int nbEle);

void MiseAJourNbPlace(VilleIUT **tiut, int nbEle);

void creationDept(VilleIUT **tiut, int nbEle);

void suppressionDept(VilleIUT **tiut, int nbEle);

void modifChefDept(VilleIUT **tiut, int nbEle);

void triEchange(VilleIUT **tiut, int nbEle);

int plusGrand(VilleIUT **tiut, int nbEle);

void echanger(VilleIUT **tiut, int i, int j);

void clearpage(void);

ListeDept creerListeDept(void);

VilleIUT **chargementVille(char *nomFich, int tphys, int *tailleL);

VilleIUT lireVille(FILE *flot);

ListeDept traiterDept(ListeDept l, FILE *flot);

ListeDept ajouterEnTeteDept(ListeDept l, char *dept, char *nom, int nbP);

void affichageListeDept(ListeDept l);

ListeDept insererDept(ListeDept l, char *dept, char *nom, int nbP);

ListeDept supprimerEnTêteDept(ListeDept l);

ListeDept supprimerDept(ListeDept l, char *code);

bool vide(ListeDept l);

ListeDept rechercheDept(ListeDept l, char code[]);

int longueurListe(ListeDept l);

void SauvegarderIUT(VilleIUT** tabV, int tailleL);

void SauvegarderListe(ListeDept l, FILE* flot);

//#######################################################
//#######################################################
//#######################################################

ListeCandid ListeCandidvide(void);

ListeCandidDept ListeCandidDeptvide(void);

ListeCandidDept insererEnTeteCandidDept(ListeCandidDept l, char departement[], int deciDept, int deciCandid);

ListeCandidDept insererCandidDept(ListeCandidDept l, char departement[], int deciDept, int deciCandid);

ListeCandid insererEnTeteCandid(ListeCandid l, char *ville);

ListeCandid insererCandid(ListeCandid l, char *ville);

ListeCandidDept suppressionEnTeteCandidDept(ListeCandidDept l);

ListeCandidDept suppressionCandidDept(ListeCandidDept l, char *departement);

ListeCandid suppressionEnTeteCandid(ListeCandid l);

ListeCandid suppressionCandid(ListeCandid l, char *ville);

void afficherCandidDept(ListeCandidDept l);

void afficherCandid(ListeCandid l);

int longueur(ListeCandid l);

Candidat **chargmentCandid(char *nomFich, int tphys, int *tailleL);

Candidat lireCandidat(FILE *flot);

ListeCandid traiterCandidIUT(ListeCandid l, FILE *flot);

ListeCandidDept traiterCandidDept(ListeCandidDept l, FILE *flot);